﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.C1Excel;

namespace C1Excel_GetStarted
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            #region Creating an Excel Book and adding sheet
            //Creating an Excel Book
            C1XLBook xlbook1 = new C1XLBook();
            
            //Adding Sheet to the Book
            xlbook1.Sheets.Clear();
            XLSheet sheet1 = xlbook1.Sheets.Add("New Sheet 1");
            sheet1.DefaultColumnWidth = 2000;
            #endregion


            #region Adding content in the Sheet
            sheet1[0, 0].Value = "OrderDate";
            sheet1[1, 0].Value = "23-01-2014";
            sheet1[2, 0].Value = "09-02-2014";
            sheet1[3, 0].Value = "26-02-2014";
            sheet1[4, 0].Value = "15-03-2014";
            sheet1[5, 0].Value = "4-1-2014";
            sheet1[6, 0].Value = "18-4-2014";
            sheet1[7, 0].Value = "5-5-2014";
            sheet1[8, 0].Value = "22-5-2014";
            sheet1[9, 0].Value = "6-8-2014";
            sheet1[10, 0].Value = "1-6-2014";

            sheet1[0, 1].Value = "Region";
            sheet1[1, 1].Value = "East";
            sheet1[2, 1].Value = "Central";
            sheet1[3, 1].Value = "Central";
            sheet1[4, 1].Value = "Central";
            sheet1[5, 1].Value = "West";
            sheet1[6, 1].Value = "East";
            sheet1[7, 1].Value = "Central";
            sheet1[8, 1].Value = "East";
            sheet1[9, 1].Value = "East";
            sheet1[10, 1].Value = "West";

            sheet1[0, 2].Value = "Representative";
            sheet1[1, 2].Value = "Jones";
            sheet1[2, 2].Value = "Kivell";
            sheet1[3, 2].Value = "Jardine";
            sheet1[4, 2].Value = "Gill";
            sheet1[5, 2].Value = "Sorvino";
            sheet1[6, 2].Value = "Jones";
            sheet1[7, 2].Value = "Andrews";
            sheet1[8, 2].Value = "Jardine";
            sheet1[9, 2].Value = "Thompson";
            sheet1[10, 2].Value = "Jones";

            sheet1[0, 3].Value = "Item";
            sheet1[1, 3].Value = "Pencil";
            sheet1[2, 3].Value = "Binder";
            sheet1[3, 3].Value = "Pencil";
            sheet1[4, 3].Value = "Pen";
            sheet1[5, 3].Value = "Pencil";
            sheet1[6, 3].Value = "Binder";
            sheet1[7, 3].Value = "Pencil";
            sheet1[8, 3].Value = "Pencil";
            sheet1[9, 3].Value = "Binder";
            sheet1[10, 3].Value = "Pen";

            sheet1[0, 4].Value = "Units";
            sheet1[1, 4].Value = 50;
            sheet1[2, 4].Value = 36;
            sheet1[3, 4].Value = 27;
            sheet1[4, 4].Value = 56;
            sheet1[5, 4].Value = 60;
            sheet1[6, 4].Value = 75;
            sheet1[7, 4].Value = 90;
            sheet1[8, 4].Value = 32;
            sheet1[9, 4].Value = 60;
            sheet1[10, 4].Value = 95;

            sheet1[0, 5].Value = "Unit Cost";
            sheet1[1, 5].Value = 1.99;
            sheet1[2, 5].Value = 19.99;
            sheet1[3, 5].Value = 4.99;
            sheet1[4, 5].Value = 19.99;
            sheet1[5, 5].Value = 2.99;
            sheet1[6, 5].Value = 4.99;
            sheet1[7, 5].Value = 1.99;
            sheet1[8, 5].Value = 4.99;
            sheet1[9, 5].Value = 1.99;
            sheet1[10, 5].Value = 8.99;

            sheet1[0, 6].Value = "Total";
            #endregion


            #region Formatting the cell content
            XLStyle style_all = new XLStyle(xlbook1);
            style_all.AlignHorz = XLAlignHorzEnum.Center;
            style_all.AlignVert = XLAlignVertEnum.Center;

            for (int j = 0; j < 7; j++)
            {
                sheet1.Columns[j].Style = style_all;
            }

            XLStyle style_header = new XLStyle(xlbook1);
            style_header.Font = new Font("Tahoma", 11, FontStyle.Bold | FontStyle.Underline);
            style_header.BackColor = Color.DarkSlateGray;
            style_header.ForeColor = Color.LightBlue;
            style_header.AlignHorz = XLAlignHorzEnum.Center;

            for (int i = 0; i < 7; i++)
            {
                // Apply styles to the content.
                sheet1[0, i].Style = style_header;
            }
            
            #endregion

            #region Styles to Rows and Columns
            XLStyle style_col = new XLStyle(xlbook1);
            style_col.Font = new System.Drawing.Font("Arial", 12, FontStyle.Bold);
            style_col.ForeColor = Color.Green;
            style_col.AlignHorz = XLAlignHorzEnum.Center;

            XLColumn col = sheet1.Columns[6];
            col.Style = style_col;
            #endregion


            #region Applying Formulas to the cell content and Summing up the cell values
            //Formula to calculate the Total units sold and Total order cost
            sheet1[11, 3].Value = "Total Units";
            sheet1[11, 4].Formula = "Sum(E2:E11)";

            sheet1[11, 5].Value = "Total Order Cost";
            sheet1[11, 6].Formula = "Sum(G2:G11)";

            //Formula to calculate the total cost
            for (int i = 2; i < 12; i++)
            {
                sheet1[i - 1, 6].Formula = "F" + i.ToString() + "*" + "E" + i.ToString();
            }

            XLStyle style_total = new XLStyle(xlbook1);
            style_total.Font = new System.Drawing.Font(style_total.Font.FontFamily, 12, FontStyle.Bold);
            style_total.SetBorderStyle(XLLineStyleEnum.Medium);
            style_total.AlignHorz = XLAlignHorzEnum.Center;

            sheet1[11, 3].Style = style_total;
            sheet1[11, 4].Style = style_total;

            sheet1[11, 5].Style = style_total;
            sheet1[11, 6].Style = style_total;

            #endregion


            #region Adding Comment to a cell
            xlbook1.Sheets[0].Comments.Add(11, 3, "Arpit", "Total Number of Units Sold");
            xlbook1.Sheets[0].Comments.Add(11, 4, "Arpit", "Total Number of Units Sold");

            xlbook1.Sheets[0].Comments.Add(11, 5, "Arpit", "Total Cost of the Order");
            xlbook1.Sheets[0].Comments.Add(11, 6, "Arpit", "Total Cost of the Order");
            #endregion


            #region Merging cells and styling
            //Select range to Merge
            XLCellRange merge_range1 = new C1.C1Excel.XLCellRange(2, 4, 1, 1);
            XLCellRange merge_range2 = new C1.C1Excel.XLCellRange(8, 9, 1, 1);
            XLCellRange merge_range3 = new C1.C1Excel.XLCellRange(7, 8, 3, 3);

            //Merge Cells
            sheet1.MergedCells.Add(merge_range1);
            sheet1.MergedCells.Add(merge_range2);
            sheet1.MergedCells.Add(merge_range3);
            #endregion


            #region Copying cell content from one sheet to another
            XLSheet sheet2 = xlbook1.Sheets.Add("New Sheet 2");
            for (int rows = 0; rows <= 11; rows++)
            {
                for (int cols = 0; cols <= 5; cols++)
                {
                    sheet2[rows, cols].Value = sheet1[rows, cols].Value;
                }
            }
            #endregion


            #region Adding PageBreaks
            sheet1.Rows[21].PageBreak = true;
            sheet1.Columns[6].PageBreak = true;
            #endregion


            #region Adding Images
            Image img = Image.FromFile("..\\..\\vbStationary.jpg");
            sheet1[13, 2].Value = img;
            #endregion


            #region Print Settings
            XLPrintSettings settings = sheet1.PrintSettings;
            settings.BlackAndWhite = true;
            settings.Copies = 2;
            settings.Header = "Sales Report";
            settings.Footer = "VB Stationers";
            settings.AlignWithMargins = true;
            settings.MarginTop = 1;
            settings.MarginBottom = 1;
            settings.MarginLeft = 0;
            settings.MarginRight = 0;
            settings.Landscape = true;
            settings.CenterHorizontal = true;
            #endregion


            #region Saving and Opening the Excel file and CSV file
            //Saving the sheet as CSV files
            sheet1.SaveCsv("..\\..\\Sheet1.csv");
            
            //Saving the Excel Book
            xlbook1.Save("..\\..\\ExcelFile.xlsx");

            //Opening the Excel Book and CSV sheet
            System.Diagnostics.Process.Start("..\\..\\ExcelFile.xlsx");
            System.Diagnostics.Process.Start("..\\..\\Sheet1.csv");

            this.Close();
            #endregion

        }
    }
}
